rawset(_G, "OnlinePlus", {})
rawset(_G, "OnlinePlusSupport", true)
rawset(_G, "OnlinePlusVersion", "\136V2 Beta")

/*
Credits area:
Aquatic Akito - SRB2Kart Join/Leave/Kick sounds (Located in Extra/JoinLeaveSounds.lua)
K.S./Inuyasha - Adventure Items (Located in Extra/MonitorModifications.lua)
WellDoneSnake - Starpost Rewards (Located in Extra/StarpostRewards.lua)


*/

//Main
local OPStartup = false

//Core

local event = "none"

//Event

local eventtimer = 0
local endeventtimer = 0
local lastevent = "last"

COM_AddCommand("OP_Welcome", function(p)
	CONS_Printf(p, " ")
	CONS_Printf(p, "\139*******************************")
	CONS_Printf(p, "	Online+ Version: "..OnlinePlusVersion.."")
	CONS_Printf(p, "\139*******************************")
	CONS_Printf(p, " ")
	CONS_Printf(p, "Welcome to a Online+ Server. This mod is aimed to enchance SRB2 multiplayer.")
	CONS_Printf(p, "The SonicD discord is https://discord.gg/ab2eTkA, where you will find details about Online+ and other SonicD modifications.")
	CONS_Printf(p, " ")
end, 0)

COM_AddCommand("OP_Credits", function(p)
	CONS_Printf(p, " ")
	CONS_Printf(p, "\136MichaelTheAvali \128for making Online+ itself")
	CONS_Printf(p, "\131Latius Auro \128for the Blue Rings Scripts")
	CONS_Printf(p, "\136Aquatic Akito \128for SRB2Kart Join/Leave/Kick Sounds script")
	CONS_Printf(p, "\137K.S./Inuyasha \128for Adventure Items Script")
	CONS_Printf(p, "\131WellDoneSnake \128for Starpost Rewards Script")
	
	CONS_Printf(p, " ")
end, 0)

COM_AddCommand("OP_Cheats", function(p)
	CONS_Printf(p, "")
	CONS_Printf(p, "\139********************")
	CONS_Printf(p, "	Cheat Commands")
	CONS_Printf(p, "\139********************")
	CONS_Printf(p, "\136SetRings - Changes your rings")
	CONS_Printf(p, "\141Setlives - Changes your lives")
	CONS_Printf(p, "\136God - Makes you unable to die")
	CONS_Printf(p, "\141Noclip - allows you to walk through walls")
	CONS_Printf(p, "\136NoTarget - Toggle invisibility to enemies")
	CONS_Printf(p, "\141Scale - Scale your character")
	CONS_Printf(p, "\136Getallemeralds - get every chaos emerald")
	CONS_Printf(p, "\141Charability - Change your jump ability")
	CONS_Printf(p, "\136Charability2 - Change your spin ability")
	CONS_Printf(p, "\141Actionspd - Speed of your jump ability")
	CONS_Printf(p, "\136Gravflip - Reverse Gravity")
	CONS_Printf(p, "\141Runonwater - Allows you to run on water")
	CONS_Printf(p, "\136Normalspeed - Changes your Top Speed")
	CONS_Printf(p, "\141Runspeed - Changes the speed your run anim starts at")
	CONS_Printf(p, "\136Acceleration - Changes how fast you speed up")
	CONS_Printf(p, "\141Mindash - Changes Min Spindash speed")
	CONS_Printf(p, "\136Maxdash - Changes Max Spindash speed")
	CONS_Printf(p, "\141Giveammo - Get all ring weapons")
	CONS_Printf(p, "\139********************")
	CONS_Printf(p, "Cheats only work if the module is enabled")
	CONS_Printf(p, "")
end, 0)

COM_AddCommand("OP_Help", function(p)
	CONS_Printf(p, "")
	CONS_Printf(p, "\139**********************")
	CONS_Printf(p, "	General Commands")
	CONS_Printf(p, "\139**********************")
	CONS_Printf(p, "OP_Welcome - Shows the welcome message")
	CONS_Printf(p, "OP_Cheats - Lists all cheats")
	CONS_Printf(p, "OP_Events - Lists all unique events")
	CONS_Printf(p, "")
	CONS_Printf(p, "\139********************")
	CONS_Printf(p, "	Admin Commands")
	CONS_Printf(p, "\139********************")
	CONS_Printf(p, "Event (Title) - Start a custom event")
	CONS_Printf(p, "Endevent - End a current event")
	CONS_Printf(p, "")
end, 0)

//Event system

COM_AddCommand("event", function(p, eventname)
    if eventname == nil then
	CONS_Printf(p, "Please enter a event name")
	else
	event = eventname
	lastevent = eventname
	eventtimer = 100
	endeventtimer = 0
	print("\131New Event has started:\128 "..eventname.."")
	S_StartSound(mo, sfx_s3k68)
	end
end, 1)

COM_AddCommand("endevent", function(p)
	if event == "none"
	CONS_Printf(p, "No events active")
	else
	endeventtimer = 100
	eventtimer = 0
	print("\3\133The event: \128"..event.." \133has ended")
	S_StartSound(mo, sfx_s3kb8)
	event = "none"
	end
end, 1)


addHook("ThinkFrame", function()
	if not OPStartup //Setup console commands
		for p in players.iterate
			if p == players[0] then
				COM_BufInsertText(p, "exitmove on")
				COM_BufInsertText(p, "inttime 6")
				OPStartup = true
			end
			if p.OPWelcome == nil //Send welcome message to new players
				CONS_Printf(p, "")
				CONS_Printf(p, "Welcome, This server is powered by Online+ "..OnlinePlusVersion)
				CONS_Printf(p, "")
				p.OPWelcome = 1
			end
		end
	end

	if eventtimer > 0
		eventtimer = $-1
	end
	
	if endeventtimer > 0
		endeventtimer = $-1
	end
end, "game")

local chatcolormaps = {
	[V_MAGENTAMAP] = "\129",
	[V_YELLOWMAP] = "\130",
	[V_GREENMAP] = "\131",
	[V_BLUEMAP] = "\132",
	[V_REDMAP] = "\133",
	[V_GRAYMAP] = "\134",
	[V_ORANGEMAP] = "\135",
	[V_SKYMAP] = "\136",
	[V_PURPLEMAP] = "\137",
	[V_AQUAMAP] = "\138",
	[V_PERIDOTMAP] = "\139",
	[V_AZUREMAP] = "\140",
	[V_BROWNMAP] = "\141",
	[V_ROSYMAP] = "\142",
	[V_INVERTMAP] = "\143"
}

addHook("PlayerMsg", function(source, msgtype, target, msg) //Nickname feature
	if ((msgtype ~= 0) and (msgtype ~= 1)) then return false end
	if (splitscreen) and not (netgame) then return false end
	if (msg:sub(1, 5):lower() == "!nick") then
		source.playernick = msg:sub(7)
		return true
	elseif source.playernick != nil
		chatprint(chatcolormaps[source.skincolor.chatcolor].."<"..source.playernick..">\128 "..msg, true)
		return true
	else
		return nil
	end
end)

//Custom Damage Stuff
addHook("MobjDamage", function(mobj, source, attacker, notused)
	mobj.player.rnggoggles = false
	mobj.player.rngtimer = 0
	if (rawget(_G, "khBlast")) != true
		if CasualModule() and (gametype == GT_COOP) //Casual mode - Inspired by the Sonic 3 A.I.R casual mod
		P_DoPlayerPain(mobj.player, attacker, source)	// Set knockback
		mobj.player.powers[pw_flashing] = 50	// Set invuln flashing
		P_PlayDeathSound(mobj, mobj.player)
		mobj.player.hits = $+1
		return true
		else
		return false
		end
	else
	return false
	end
end, MT_PLAYER)

COM_AddCommand("OP_ResetHits", function(p) //Casual mode - Reset hits
	for ply in players.iterate
		ply.hits = 0
	end
end, 1)

hud.add(function(v, player)
	if player.bot then return end //Ignore bots
	if eventtimer > 0
		v.drawString(160, 50, "\131New Event has started\128 ", V_ALLOWLOWERCASE|V_SNAPTOTOP, "center")
		v.drawString(160, 60, event, V_ALLOWLOWERCASE|V_SNAPTOTOP, "center")
	end

	if endeventtimer > 0
		v.drawString(160, 40, "\3\133The event \128", V_ALLOWLOWERCASE|V_SNAPTOTOP, "center")
		v.drawString(160, 50, lastevent, V_ALLOWLOWERCASE|V_SNAPTOTOP, "center")
		v.drawString(160, 60, "\133has ended", V_ALLOWLOWERCASE|V_SNAPTOTOP, "center")
	end
end, "game")

//Hooks

addHook("NetVars", function(net)
	event = net(event)
end)

addHook("MapLoad", do
	for p in players.iterate
		p.hits = 0
	end
end)

//HUD


hud.add(function(v)
	v.drawString(320, 192, "Online+ Version: "..OnlinePlusVersion.."", V_ALLOWLOWERCASE|V_40TRANS, "right")
end, "scores")

hud.add(function(v)
	v.drawString(320, 192, OnlinePlusVersion, V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOBOTTOM, "right")
	v.draw(238, 176, v.cachePatch("OPTITLE"), V_SNAPTORIGHT|V_SNAPTOBOTTOM)
	
	//SonicD Icon
	v.drawScaled(320*FRACUNIT, 0, FRACUNIT/2, v.cachePatch("SDICON"), V_SNAPTORIGHT|V_SNAPTOTOP|V_20TRANS)
	v.drawString(312, 34, "A SonicD Mod", V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP|V_20TRANS, "small-right")
end, "title")

hud.add(function(v, p)
	if CasualModule() and (gametype == GT_COOP)
		v.drawString(66, 192, "Hits: "..p.hits, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS, "right")
	end
end, "game")