local OPPitsaver = CV_RegisterVar({"OP_Modules_PitSaver", "Off", CV_NETVAR, CV_OnOff, CV_SHOWMODIF})
local OPDragonMonitors = CV_RegisterVar({"OP_Modules_DragonMonitors", "On", CV_NETVAR, CV_OnOff, CV_SHOWMODIF})
local OPRedStarRings = CV_RegisterVar({"OP_Modules_RedStarRings", "On", CV_NETVAR, CV_OnOff, CV_SHOWMODIF})
local OPCasualMode = CV_RegisterVar({"OP_Modules_CasualCoop", "Off", CV_NETVAR, CV_OnOff, CV_SHOWMODIF})
local OPCheats = CV_RegisterVar({"OP_Modules_Cheats", "Off", CV_NETVAR, CV_OnOff, CV_SHOWMODIF})

//Module Global Values

//Pit Saver
rawset(_G, "PitsaverModule", function()
	return OPPitsaver.value
end)

//Dragon Edition Monitors
rawset(_G, "DragonMonitorsModule", function()
	return OPDragonMonitors.value
end)

//Red Star Rings
rawset(_G, "RedStarRingModule", function()
	return OPRedStarRings.value
end)

rawset(_G, "CasualModule", function()
	return OPCasualMode.value
end)

rawset(_G, "CheatModule", function()
	return OPCheats.value
end)

addHook("ThinkFrame", function()	
	if (gametype == GT_COOP)
		if OPPitsaver.value //Pit Saver module - Records the player's last ground location
			for p in players.iterate
				if p.mo
					if P_IsObjectOnGround(p.mo)
						p.psgroundX = p.mo.x
						p.psgroundY = p.mo.y
						p.psgroundZ = p.mo.z
						p.psflags = p.mo.flags
					end
				end
			end
		end
	end
end, "game")

addHook("MobjDeath", function(mobj, attacker, source)
	if (gametype == GT_COOP)
		if OPPitsaver.value //Pit Saver module - Takes away the player's rings and respawns them at the last location they touched the ground
			if mobj.player.rings > 0
				P_TeleportMove(mobj, mobj.player.psgroundX, mobj.player.psgroundY, mobj.player.psgroundZ)
				mobj.health = 1
				mobj.player.powers[pw_flashing] = 50	// Set invuln flashing
				mobj.player.playerstate = 0
				mobj.state = 3
				mobj.player.state = 3
				mobj.flags = mobj.player.psflags
				P_PlayDeathSound(mobj, mobj.player)
				mobj.player.rings = 0
				return true
			else
				return false
			end
		else
		return false
		end
	end
end, MT_PLAYER)

