local function drawLetter(v, font, char, x, y, f, c)
	local asc = string.byte(char)
	local padding = "000"
	if asc > 99
		padding = ""
	elseif asc > 9
		padding = "0"
	elseif asc > 0
		padding = "00"
	end
	v.draw(x, y, v.cachePatch(font .. padding .. tostring(asc)), f, c)
end

rawset(_G, "drawFontString", function(v, font, str, x, y, spacing, f, c)
	if str == nil
	or string.len(str) == 0
		str = "NIL"
	end
	for a=1,string.len(str) do
		drawLetter(v, font, string.sub(str, a, a), x + ((a - 1) * spacing), y, f, c)
	end
end)

rawset(_G, "IsBattleModes", function()
	return gametype >= GT_RACE and gametype <= GT_CTF
end)