local RSRAmount = 0
local RSRCollected = 0

freeslot(
"SPR_TVRG",
"S_BLUERINGINVIS",
"S_BLUERINGVIS",
"MT_BLUEINVISRING",
"S_BGTV",
"S_BGTV1",
"S_BGTV2",
"S_BGTV3",
"S_BGTV4",
"S_BGTV5",
"S_BGTV6",
"MT_GOGGLEMONITOR",
"MT_GOGGLEICO",
"S_GGTV",
"S_GGTV1",
"S_GGTV2",
"S_GGTV3",
"S_GGTV4",
"S_GGTV5",
"S_GGTV6",
"MT_GOLDGOGGLEMONITOR",
"MT_GGOGGLEICO"
)

function A_DoRingGoggles(actor, var1, unused)
	//This grants the player the Ring Goggles.
	//If var1 is given, this determines the time limit for the goggles,
	//otherwise the goggles will last until the player dies
	if not actor.target then return end
	if not actor.target.player then return end
	local player = actor.target.player
	
	if player.rnggoggles and not player.rngtimed then
		//Play an error sound
		return
	end
	
	if not player.rnggoggles then player.rnggoggles = true 
		if (rawget(_G, "khBlast")) == true
			if player.kh then
				player.kh.itempickuptext = "The ability to collect blue rings!"
				player.kh.itempickuptimer = TICRATE * 6
			end
		end
	end
	
	if (var1 == nil) or (var1 == 0) then
		if player.rngtimed then player.rngtimed = false end
	else
		player.rngtimer = $ + (var1 * TICRATE)
		player.rngtimed = true
		if (rawget(_G, "khBlast")) == true
			if player.kh then
				player.kh.itempickuptext = "The ability to temporally collect blue rings!"
				player.kh.itempickuptimer = TICRATE * 6
			end
		end
	end
end

states[S_BLUERINGINVIS] = {
	sprite = SPR_TRNG,
	frame = FF_ANIMATE|TR_TRANS50,
	tics = -1,
	var1 = 23,
	var2 = 1
}

states[S_BLUERINGVIS] = {
	sprite = SPR_TRNG,
	frame = FF_ANIMATE,
	tics = -1,
	var1 = 23,
	var2 = 1
}

states[S_BGTV] = {
	sprite = SPR_TVRG,
	frame = A,
	tics = 2,
	var1 = 0,
	var2 = 0,
	nextstate = S_BGTV1
}

states[S_BGTV1] = {
	sprite = SPR_MSTV,
	frame = A,
	tics = 1,
	var1 = 0,
	var2 = 0,
	nextstate = S_BGTV
}

states[S_GGTV] = {
	sprite = SPR_TVRG,
	frame = B,
	tics = 2,
	action = A_GoldMonitorSparkle,
	var1 = 30,
	var2 = 0,
	nextstate = S_GGTV1
}

states[S_GGTV1] = {
	sprite = SPR_XLTV,
	frame = A,
	tics = 1,
	action = A_GoldMonitorSparkle,
	var1 = 30,
	var2 = 0,
	nextstate = S_GGTV
}

states[S_BGTV2] = {
	sprite = SPR_TVRG,
	frame = C,
	tics = 4,
	action = A_MonitorPop,
	var1 = 0,
	var2 = 0,
	nextstate = S_BGTV3
}

states[S_BGTV3] = {
	sprite = SPR_YLTV,
	frame = D,
	tics = 4,
	var1 = 0,
	var2 = 0,
	nextstate = S_BGTV4
}

states[S_BGTV4] = {
	sprite = SPR_YLTV,
	frame = E,
	tics = 4,
	var1 = 0,
	var2 = 0,
	nextstate = S_BGTV5
}

states[S_BGTV5] = {
	sprite = SPR_YLTV,
	frame = F,
	tics = 4,
	var1 = 0,
	var2 = 0,
	nextstate = S_BGTV6
}

states[S_BGTV6] = {
	sprite = SPR_TVRG,
	frame = C,
	tics = 18,
	action = A_DoRingGoggles,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

states[S_GGTV2] = {
	sprite = SPR_TVRG,
	frame = C,
	tics = 4,
	action = A_MonitorPop,
	var1 = 30,
	var2 = 0,
	nextstate = S_GGTV3
}

states[S_GGTV3] = {
	sprite = SPR_YLTV,
	frame = D,
	tics = 4,
	var1 = 0,
	var2 = 0,
	nextstate = S_GGTV4
}

states[S_GGTV4] = {
	sprite = SPR_YLTV,
	frame = E,
	tics = 4,
	var1 = 0,
	var2 = 0,
	nextstate = S_GGTV5
}

states[S_GGTV5] = {
	sprite = SPR_YLTV,
	frame = F,
	tics = 4,
	var1 = 0,
	var2 = 0,
	nextstate = S_GGTV6
}

states[S_GGTV6] = {
	sprite = SPR_TVRG,
	frame = C,
	tics = 18,
	action = A_DoRingGoggles,
	var1 = 30,
	var2 = 0,
	nextstate = S_NULL
}

mobjinfo[MT_GOGGLEMONITOR] = {
		//$Name Blue Ring Goggles
		//$Sprite TCRGA0
		//$Category Online+ Custom Monitors
		doomednum = 3002,
		spawnstate = S_BGTV,
		painstate = S_BGTV,
		deathsound = sfx_pop,
		deathstate = S_BGTV2,
		xdeathstate = S_BOX_POP1,
		spawnhealth = 1,
		reactiontime = 8,
		speed = 1,
		radius = 16*FRACUNIT,
		height = 32*FRACUNIT,
		damage = MT_GOGGLEICO,
		flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}

mobjinfo[MT_GOLDGOGGLEMONITOR] = {
		//$Name Blue Ring Goggles (Respawn)
		//$Sprite TCRGB0
		//$Category Online+ Custom Monitors
		doomednum = 3003,
		spawnstate = S_GGTV,
		painstate = S_GGTV,
		attacksound = sfx_monton,
		deathsound = sfx_pop,
		deathstate = S_GOLDBOX_OFF1,
		spawnhealth = 1,
		reactiontime = 8,
		speed = 1,
		radius = 20*FRACUNIT,
		height = 44*FRACUNIT,
		damage = MT_GGOGGLEICO,
		flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR|MF_GRENADEBOUNCE
}


mobjinfo[MT_GOGGLEICO] = {
		spawnstate = S_BGTV2,
		seesound = sfx_shield,
		spawnhealth = 1,
		reactiontime = 8,
		speed = 2*FRACUNIT,
		radius = 8*FRACUNIT,
		height = 14*FRACUNIT,
		damage = 62*FRACUNIT,
		flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON
}

mobjinfo[MT_GGOGGLEICO] = {
		spawnstate = S_GGTV2,
		seesound = sfx_shield,
		spawnhealth = 1,
		reactiontime = 8,
		speed = 2*FRACUNIT,
		radius = 8*FRACUNIT,
		height = 14*FRACUNIT,
		damage = 62*FRACUNIT,
		flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON
}

mobjinfo[MT_BLUEINVISRING] = {
		//$Name Blue Ring
		//$Sprite TRNGA0
		//$Category Online+ Custom Objects
		doomednum = 3001,
        spawnstate = S_BLUERINGINVIS,
		deathsound = sfx_itemup,
        spawnhealth = 1,
		radius = 16*FRACUNIT,
        height = 24*FRACUNIT,
        dispoffset = 0,
        flags = MF_SLIDEME|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

/*
	
*/

addHook("MapLoad", function()
	RSRAmount = 0
	RSRCollected = 0
	for p in players.iterate() do
		if p.rnggoggles == nil then
			p.rnggoggles = false
			p.rngtimer = 0
			p.rngtimed = false
			p.rngflash = false
			p.rngflashtimer = 60
		end
		if p.mo and p.mo.valid then
			if p.mo.health == 0 then
				p.rnggoggles = false
				p.rngtimer = 0
				p.rngtimed = false
				p.rngflash = false
				p.rngflashtimer = 60
			end
		end
	end

	for mapthing in mapthings.iterate do
		if mapthing.type == 3001
			mapthing.mobj.color = SKINCOLOR_SKY
			if mapthing.options & MTF_AMBUSH
				mapthing.mobj.z = $+24*FRACUNIT
			end
		end
	end
end)

addHook("PlayerSpawn", function(p)
	p.rnggoggles = false
	p.rngtimer = 0
	p.rngtimed = false
	p.rngflash = false
	p.rngflashtimer = 60
end)

addHook("MobjThinker", function(ring)	
	for p in players.iterate() do
		P_BossTargetPlayer(ring, true)
		if p.mo == ring.target
			if R_PointToDist2(ring.x, ring.y, p.mo.x, p.mo.y)/10000 < 5000 and p.rnggoggles
				if ring.state != S_BLUERINGVIS
					ring.state = S_BLUERINGVIS
					ring.flags = $1|MF_SPECIAL
				end
			elseif ring.state != S_BLUERINGINVIS
				ring.state = S_BLUERINGINVIS
				ring.flags = $1 & !MF_SPECIAL
			end
		end	
	end

end, MT_BLUEINVISRING) 

addHook("TouchSpecial", function(special, toucher)
	P_GivePlayerRings(toucher.player, 1)
end, MT_BLUEINVISRING)

addHook("ThinkFrame", do
	for p in players.iterate
		if p.rngtimed
			if p.rnggoggles and p.rngtimer != 0 and p.rngtimed == true
				p.rngtimer = $-1
			elseif p.rnggoggles and p.rngtimer == 0 and p.rngtimed == true
				p.rnggoggles = false
			end
		end
	end
end)

hud.add(function(v, p)
	if p.rnggoggles then
		v.draw(160, 5, v.cachePatch("RNGGOG"), V_SNAPTOLEFT|V_SNAPTOTOP)
		if p.rngtimed == true
			if p.rngtimer < TICRATE*10 and ((p.rngtimer % 10) < 5) then 
				v.drawString(160, 12, p.rngtimer/TICRATE, V_SNAPTOLEFT|V_SNAPTOTOP|V_REDMAP, "small")
			else
				v.drawString(160, 12, p.rngtimer/TICRATE, V_SNAPTOLEFT|V_SNAPTOTOP, "small")
			end
		end
	end
end, "game")

COM_AddCommand("togglegoggles", function(p)
    if p.rnggoggles
	p.rnggoggles = false
	p.rngtimer = 0
	p.rngtimed = false
	else
	p.rnggoggles = true
	p.rngtimer = TICRATE*30
	p.rngtimed = true
	end
end, 1)