rawset(_G, "RedStarRingAmount", 0)
rawset(_G, "RedStarRingHeld", 0)

local EMTAmount = 0
local EMTCollected = 0
local RedStarActive = false
local RedStarJustOnce = false

freeslot(
"SPR_SRNG",
"SPR_SRNB",
"S_STARRING",
"S_STARRINGBASE",
"MT_STARRING",
"MT_STARRINGBASE"
)

states[S_STARRINGBASE] = {
	sprite = SPR_SRNB,
	frame = A,
	tics = -1,
	var1 = 5,
	var2 = 5
}

states[S_STARRING] = {
	sprite = SPR_SRNG,
	frame = FF_ANIMATE,
	tics = -1,
	var1 = 7,
	var2 = 3
}

mobjinfo[MT_STARRING] = {
		//$Name Red Star Ring
		//$Sprite SRNGA0
		//$Category Online+ Custom Objects
        doomednum = 3000,
        spawnstate = S_STARRING,
        spawnhealth = 1,
		radius = 16*FRACUNIT,
        height = 24*FRACUNIT,
        dispoffset = 0,
        flags = MF_SLIDEME|MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_STARRINGBASE] = {
        spawnstate = S_STARRINGBASE,
        spawnhealth = 1,
        flags = MF_SLIDEME|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

addHook("NetVars", function(net)
	EMTAmount = net($)
	EMTCollected = net($)
	
	RedStarRingAmount = net($)
    RedStarRingHeld = net($)
	
	RedStarActive = net($)
	RedStarJustOnce = net($)
end)

/*
addHook("ThinkFrame", function()	
	if ((RedStarActive == true) and not (RedStarRingModule())) or ((RedStarActive == false) and (RedStarRingModule()))
		if RedStarJustOnce == false
			print("You must restart the map for the Red Star Ring module to update")
			RedStarJustOnce = true
		end
	elseif RedStarJustOnce
		RedStarJustOnce = false
	end
end, "game")
*/

addHook("MapLoad", function()
	RedStarRingAmount = 0
	RedStarRingHeld = 0
	EMTAmount = 0
	EMTCollected = 0
	if RedStarRingModule()
		RedStarActive = true
	else
		RedStarActive = false
	end

	for mapthing in mapthings.iterate do
		if mapthing.type == 3000
		RedStarRingAmount = $ + 1
			if mapthing.options & MTF_OBJECTSPECIAL
				P_SpawnMobjFromMobj(mapthing.mobj, 0, 0, 0, MT_STARRINGBASE)
			end
		end
	end
	
/*
	if multiplayer
		if RedStarActive
			if (gametype == GT_COOP)
				for mapt in mapthings.iterate
					if mapt.type == 322
						local x = mapt.x*FRACUNIT
						local y = mapt.y*FRACUNIT
						P_SpawnMobj(x, y, R_PointInSubsector(x, y).sector.floorheight + 32*FRACUNIT + mapt.z*FRACUNIT, MT_STARRING)
						RedStarRingAmount = $ + 1
					end
				end
			end
		end
	end
*/
	
	
	//Token Counter is here for HUD reasons
	for mapthing in mapthings.iterate do
		if mapthing.type == 312
		EMTAmount = $ + 1
		end
	end
	
	if RedStarRingAmount > 0
		EMTAmount = $ + 1
	end
end)

addHook("TouchSpecial", function(special, toucher)
	S_StartSound(special.mo, sfx_rsr, toucher.player)
	RedStarRingHeld = $ + 1
	if RedStarRingHeld == RedStarRingAmount
		P_SpawnMobj(toucher.x, toucher.y, toucher.z, MT_TOKEN)
	else
		P_AddPlayerScore(toucher.player, 100)
	end
	if (rawget(_G, "khBlast")) == true
		if toucher.player.kh then
			toucher.player.kh.itempickuptext = "a Red Star Ring!"
			toucher.player.kh.itempickuptimer = TICRATE * 6
		end
	end
end, MT_STARRING)

//Token Counter is here for HUD reasons
addHook("TouchSpecial", function(special, toucher)
	EMTCollected = $ + 1
end, MT_TOKEN)

local debugX = 30
local debugY = 31
local debugS = 17

COM_AddCommand("DebugHud", function(p, x, y)
	debugX = x
	debugY = y
	CONS_Printf(p, x.." ,"..y)
end, 0)

COM_AddCommand("DebugSpace", function(p, s)
	debugS = s
	CONS_Printf(p, x)
end, 0)

//Token/Red Star Ring Counters
hud.add(function(v, p)
if IsBattleModes() != true
	if rawget(_G, "ISWARE") != true
		if RedStarActive
			if RedStarRingAmount != 0
				v.draw(33 - 19 , 56 + 16, v.cachePatch("RSRING"), V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS)
				v.drawString(33, 56 + 20, RedStarRingHeld.."/"..RedStarRingAmount, V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, left)
			end
		end
	if EMTAmount != 0
			v.draw(33 - 19, 56, v.cachePatch("HUDTOKE"), V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS)
			v.drawString(33, 56 + 4, EMTCollected.."/"..EMTAmount, V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, right)
		else
		v.draw(33 - 19, 56, v.cachePatch("HUDNTOKE"), V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS)
		end
	end
end
end, "game")